
Redmine - Defect #26376

Wrong issue counts and spent time on project overview

2017-07-06 19:47 - Serhiy Yefremenko

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Jean-Philippe Lang % Done: 0%

Category: Projects Estimated time: 0.00 hour

Target version: 3.4.1   

Resolution: Fixed Affected version: 3.4.0

Description

After switching to 3.4.0 from 3.3.3 got the problem on project overview page. With non-admin user issue table is empty and total

spent time is 0.0, even though "all issues" page and time report show correct data.

I saw related issues posted here but open new one because another version is affected and also because it seems to me that I found

the reason.

I was able to trace the bug to the method User#project_ids_by_role, which returned wrong data. The actual reason lives in :visible

scope of Project:

scope :visible, lambda {|*args| where(Project.visible_condition(args.shift || User.current, *args)

) }

Because of this method chain, any query to Project from User#project_ids_by_role adds condition for parent id. So even if you place

break point inside that method and call Project.first, you will get something like

SELECT * FROM Project WHERE project.id = ? LIMIT 1

 Looks like it's a bug affecting ActiveRecord 4.2.8, discussed here:

https://github.com/rails/rails/issues/29445

https://github.com/rails/rails/issues/29338

The actual problem with missing issues and time can be solved commenting first line in User#project_ids_by_role (result caching) but

it's not a valid solution. Also 3.3.3 and 3.3.4 seem to do same things but the bug is not reproduced on our data so we stick with 3.3.4

for now.

Related issues:

Related to Redmine - Defect #25828: Issue visibility problems on 3.3.1 New

Has duplicate Redmine - Defect #26084: In my Overview column didn't show bugs... Closed

Has duplicate Redmine - Defect #26389: summary issue list disappeared from pr... Closed

Associated revisions

Revision 16766 - 2017-07-08 09:20 - Jean-Philippe Lang

Fixed that issue counts are 0 on project overview (#26376).

Revision 16767 - 2017-07-08 14:15 - Jean-Philippe Lang

Fixed User#project_ids_by_role when first called within chained scopes (#26376).

Revision 16768 - 2017-07-08 14:16 - Jean-Philippe Lang

Reverts change made to ProjectController in r16766 (#26376).

Revision 16771 - 2017-07-08 14:56 - Jean-Philippe Lang

Merged r16766 to r16768 (#26376).

History

#1 - 2017-07-07 12:12 - Serhiy Yefremenko

UPD: 3.3.4 is probably fine as it uses rails 4.2.7.1

2025-05-01 1/2

https://github.com/rails/rails/issues/29445
https://github.com/rails/rails/issues/29338


#2 - 2017-07-08 03:48 - Go MAEDA

- Has duplicate Defect #26084: In my Overview column didn't show bugs count added

#3 - 2017-07-08 04:03 - Go MAEDA

Screenshots from #26084:
#4 - 2017-07-08 04:16 - Go MAEDA

- Target version set to 3.4.1

#5 - 2017-07-08 09:25 - Jean-Philippe Lang

- Subject changed from Project/Tracker visibility control fails, presumably because of ActiveRecord bug to Wrong issue counts and spent time on

project overview

- Status changed from New to Resolved

- Assignee set to Jean-Philippe Lang

- Resolution set to Fixed

I was able to fix the problem on the project overview by loading visible subprojects (which poisons project_ids cache) at the end. I'll see if we can

workaround this Rails bug with a more general solution.

#6 - 2017-07-08 11:02 - Serhiy Yefremenko

Isn't disabling cache safer? Or rolling back to rails 4.2.7, didn't have time to check if that version works but one of that github issues says it does.

#7 - 2017-07-08 14:18 - Jean-Philippe Lang

Serhiy Yefremenko wrote:

Isn't disabling cache safer? Or rolling back to rails 4.2.7

 We can't stick to 4.2.7 for ever and the issue does not seem to be addressed in Rails 5.

I've committed a better fix in r16767 that ensures that User#project_ids_by_role always returns correct results.

#8 - 2017-07-08 14:57 - Jean-Philippe Lang

- Status changed from Resolved to Closed

I think we have to release a 3.4.1 ASAP.

#9 - 2017-07-10 07:56 - Go MAEDA

- Has duplicate Defect #26389: summary issue list disappeared from project overview page added

#10 - 2017-07-24 19:42 - Udo Hain

I just want to mention that I have the same problem with the following environment (on Ubuntu 16.04.2 LTS):

Environment:

  Redmine version                3.2.1.stable

  Ruby version                   2.3.1-p112 (2016-04-26) [x86_64-linux-gnu]

  Rails version                  4.2.9

  Environment                    production

  Database adapter               Mysql2

 I have solved the problem with the empty list in the issue tracking table by a patch described in #25828, but the problem with the "Spent time" of 0.0

hours remains. Admin accounts see the correct time, the other users do not. It would be nice if there was a patch for 3.2.1 too!

#11 - 2017-08-05 05:33 - Toshi MARUYAMA

- Related to Defect #25828: Issue visibility problems on 3.3.1 added
